#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofBackground(0,0,0);
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	picture.loadImage("ufo.png");
	picture2.loadImage("asteroid.png");

	back.loadImage("universe.jpg");

	/*
	for (int i = 0; i < 500; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		particles.push_back(myParticle);
	}*/
	
	for (int i = 0; i<20; i++) {
		for (int j = 0 ; j<15; j++) {
			particle myParticle;
			ofPoint temp;
			temp.set(i*55, j*55);			
			myParticle.setInitialCondition(temp.x,temp.y,0,0);
			initPos.push_back(temp);


			//myParticle.setInitialCondition(i*20,j*20,0,0);

			particles.push_back(myParticle);		
		}
	}

	//declare objects
	for (int i = 0; i<3; i++) {
			particle myParticle;
			ofPoint temp;
			temp.set(0, ofRandom(0, ofGetHeight()));			
			myParticle.setInitialCondition(temp.x,temp.y,0,0);
			
			
			//myParticle.setInitialCondition(i*20,j*20,0,0);
			
			movingParticles.push_back(myParticle);		
		}
	//Vector field
	VF.setupField(60,40,ofGetWidth(), ofGetHeight());
	VF.randomizeField(3.0);
	drawingStyle = 0;

	
}

//--------------------------------------------------------------
void testApp::update(){
	
	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update




	VF.fadeField(0.99);
	for (int i = 0; i < movingParticles.size(); i++){
		
		movingParticles[i].resetForce();
		movingParticles[i].addAttractionForce(mouseX, mouseY, 600, 1.2f);

		
		for (int j = 0; j < i; j++){
			movingParticles[i].addRepulsionForce(movingParticles[j], 100, 3.0);
			movingParticles[i].addAttractionForce(movingParticles[j], 500, 0.1);
			
		}
		
		//particles[i].addAttractionForce(mouseX, mouseY, 600, 0.3f);
		movingParticles[i].addRepulsionForce(movingParticles[i].pos.x, movingParticles[i].pos.x, 100, 1.0f);		
		
		
		movingParticles[i].addDampingForce();
		//movingParticles[i].invertWalls();
		movingParticles[i].bounceOffWalls();
		movingParticles[i].update();

		
	}
	

	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		ofxVec2f frc;
		frc = VF.getForceFromPos(particles[i].pos.x, particles[i].pos.y);
		particles[i].addForce(frc.x, frc.y);
		
		particles[i].pos.x++;
		particles[i].pos.y=particles[i].pos.y+2*cos(ofGetElapsedTimef()) ;

		for (int ii =0; ii<movingParticles.size(); ii++) {
		
			particles[i].addRepulsionForce(movingParticles[ii], 200, 3.4);

			if(ofDist(particles[i].pos.x, particles[i].pos.y, movingParticles[ii].pos.x, movingParticles[ii].pos.y)>10){
				ofSetColor(255, 0, 0);
				ofLine(particles[i].pos.x, particles[i].pos.y, movingParticles[ii].pos.x, movingParticles[ii].pos.y);
			}
		}
		
		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 50, 5.0);
			//particles[i].addAttractionForce(particles[j], 200, 0.1);
			
			//particles[i].addCounterClockwiseForce(particles[j], 100, 0.6);
			//particles[i].addClockwiseForce(particles[j], 600, 0.03);
			
		}
		particles[i].invertWalls();
		particles[i].addDampingForce();
		particles[i].update();
		
	}
	
	
	/*
	//return to initial position
	
	
	for (int i = 0; i<particles.size(); i++) {
		float catchUpSpeed = 0.04f;
		particles[i].pos.x = catchUpSpeed * initPos[i].x + (1-catchUpSpeed) * particles[i].pos.x; 
		particles[i].pos.y = catchUpSpeed * initPos[i].y + (1-catchUpSpeed) * particles[i].pos.y; 
		
		}*/

	}

//--------------------------------------------------------------
void testApp::draw(){
	
	VF.draw();
	ofEnableAlphaBlending();
	ofSetColor(255, 255, 255,255);
	back.draw(0,0,ofGetWidth(),ofGetHeight());
	for (int i = 0; i < particles.size(); i++){
	

		particles[i].draw(&picture2);
	}
	
	for (int i=0; i<movingParticles.size(); i++) {
		movingParticles[i].draw2(&picture);
		VF.addOutwardCircle(movingParticles[i].pos.x, movingParticles[i].pos.y, 100, 0.2f);
		VF.addClockwiseCircle(movingParticles[i].pos.x, movingParticles[i].pos.y, 100, 0.2f);


	}
	
	ofDisableAlphaBlending();

	
	for (int i = 0; i < particles.size(); i++){
		
		for (int ii =0; ii<movingParticles.size(); ii++) {
			
			
			if(ofDist(particles[i].pos.x, particles[i].pos.y, movingParticles[ii].pos.x, movingParticles[ii].pos.y)<100){
				ofSetColor(255, 255, 0);
				ofLine(particles[i].pos.x, particles[i].pos.y, movingParticles[ii].pos.x, movingParticles[ii].pos.y);
				//particles[i].erase();
			}
		}
	}
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	} 
	
	if(key == 'a'){
		drawingStyle ++;
		drawingStyle %= 4;
	}

	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	if (button == 0) {
		switch (drawingStyle){
			case 0: VF.addInwardCircle((float)x, (float)y, 200, 0.3f);
				break;
			case 1: VF.addOutwardCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 2: VF.addClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 3: VF.addCounterClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
		}		
	}
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
	

	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
